/******************************************************************************
|* THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
|* ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
|* THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
|* PARTICULAR PURPOSE.
|* 
|* Copyright 1995-2003 Ahead Software AG. All Rights Reserved.
|*-----------------------------------------------------------------------------
|* NeroSDK / AudioPluginManager
|*
|* FILE: audiopluginenviid.h
|*
|* PURPOSE: Definitions of the interface GUIDs for the audio plugin manager 
|*          interfaces
******************************************************************************/

#ifndef _AUDIO_PLUGIN_ENV_IID_
#	define _AUDIO_PLUGIN_ENV_IID_

EXTERN_GUID(IID_IStatus, 0xc6d81a4a, 0xa3cb, 0x4d32, 0x9b, 0xb9, 0xb3, 0x70, 0xbc, 0x4e, 0xde, 0x6c);
struct __declspec(uuid("C6D81A4A-A3CB-4d32-9BB9-B370BC4EDE6C")) IStatus;

EXTERN_GUID(IID_IStatusCategory, 0x3ccd01a1, 0x474c, 0x4517, 0xa9, 0xc4, 0xd1, 0xe3, 0xd, 0x62, 0x92, 0x2b );
struct __declspec(uuid("3CCD01A1-474C-4517-A9C4-D1E30D62922B")) IStatusCategory;

EXTERN_GUID(IID_IProcess, 0xb388f5e3, 0x94b2, 0x40ff, 0xbc, 0xe9, 0xa, 0xc8, 0xdb, 0xf5, 0x51, 0xcb);
struct __declspec(uuid("B388F5E3-94B2-40ff-BCE9-0AC8DBF551CB")) IProcess;

EXTERN_GUID(IID_IURLHolder, 0xfa6a3cf1, 0xe837, 0x42c2, 0xad, 0xdc, 0x8b, 0x50, 0x44, 0xd6, 0x84, 0x8e);
struct __declspec(uuid("FA6A3CF1-E837-42c2-ADDC-8B5044D6848E")) IURLHolder;

EXTERN_GUID(IID_IAggregatable, 0xbd8395af, 0x39ed, 0x4ddc, 0x95, 0xcf, 0x5d, 0xff, 0x46, 0x20, 0xe2, 0x79);
struct __declspec(uuid("BD8395AF-39ED-4ddc-95CF-5DFF4620E279")) IAggregatable;

EXTERN_GUID(IID_IAudioItem, 0xb7381fad, 0xb9c, 0x4cbb, 0x9e, 0xb6, 0x7e, 0xd7, 0x3d, 0x8b, 0xf8, 0xf9);
struct __declspec(uuid("B7381FAD-0B9C-4cbb-9EB6-7ED73D8BF8F9")) IAudioItem;

EXTERN_GUID(IID_IAudioRawReader, 0x3f1bcd1c, 0x90e7, 0x467b, 0x9f, 0x75, 0xe8, 0xd8, 0xe5, 0xd6, 0x1b, 0xda);
struct __declspec(uuid("3F1BCD1C-90E7-467b-9F75-E8D8E5D61BDA")) IAudioRawReader;

EXTERN_GUID(IID_IPausable, 0xc1b59d0a, 0xcfcc, 0x4c82, 0x98, 0xb, 0x8d, 0xda, 0x8c, 0xfe, 0x7d, 0x6d);
struct __declspec(uuid("C1B59D0A-CFCC-4c82-980B-8DDA8CFE7D6D")) IPausable;

EXTERN_GUID(IID_IAudioRawReceiver, 0x8f5f19d6, 0x35dc, 0x48b5, 0xae, 0x4d, 0x12, 0x99, 0xba, 0x5b, 0x20, 0xbd);
struct __declspec(uuid("8F5F19D6-35DC-48b5-AE4D-1299BA5B20BD")) IAudioRawReceiver;

EXTERN_GUID(IID_IPlayable, 0x1119804, 0xf1c3, 0x4fc5, 0x81, 0x91, 0x8d, 0x69, 0xac, 0x4f, 0xa4, 0x3e);
struct __declspec(uuid("01119804-F1C3-4fc5-8191-8D69AC4FA43E")) IPlayable;

EXTERN_GUID(IID_IAudioSource, 0x97419caa, 0x38e4, 0x4a93, 0x98, 0x95, 0xe0, 0x3f, 0xb9, 0x6f, 0x25, 0x3e);
struct __declspec(uuid("97419CAA-38E4-4a93-9895-E03FB96F253E")) IAudioSource;

EXTERN_GUID(IID_IURLAudioSourceFactory, 0xc69677f6, 0x15f4, 0x4555, 0xb5, 0x5e, 0x4f, 0xf3, 0xe0, 0xee, 0x84, 0x77);
struct __declspec(uuid("C69677F6-15F4-4555-B55E-4FF3E0EE8477")) IURLAudioSourceFactory;

EXTERN_GUID(IID_IAudioRawConvertor, 0xcb403c0d, 0x7e0e, 0x4323, 0x8f, 0xc, 0xe6, 0xd1, 0x15, 0xa4, 0xe5, 0x9b);
struct __declspec(uuid("CB403C0D-7E0E-4323-8F0C-E6D115A4E59B")) IConvertor;

EXTERN_GUID(IID_IConvertorFactory, 0xab16a32c, 0xf6b0, 0x4c31, 0x98, 0x93, 0x36, 0x94, 0x2d, 0x66, 0x5, 0x71);
struct __declspec(uuid("AB16A32C-F6B0-4c31-9893-36942D660571")) IConvertorFactory;

EXTERN_GUID(IID_IEventReceiver, 0xb515abec, 0x9c36, 0x494f, 0x8f, 0xf2, 0xc5, 0x2d, 0x77, 0x4a, 0x5, 0x91);
struct __declspec(uuid("B515ABEC-9C36-494f-8FF2-C52D774A0591")) IEventReceiver;

EXTERN_GUID(IID_IAudioComponent, 0xd7ea5c4, 0xdaf9, 0x4738, 0xbb, 0x57, 0xee, 0xfd, 0xe3, 0x9c, 0xff, 0x8c);
struct __declspec(uuid("0D7EA5C4-DAF9-4738-BB57-EEFDE39CFF8C")) IAudioComponent;

EXTERN_GUID(IID_IComponentEnum, 0xfc2e77b1, 0x6278, 0x452b, 0x97, 0x56, 0x7a, 0xc2, 0x4e, 0x80, 0x77, 0x78);
struct __declspec(uuid("FC2E77B1-6278-452b-9756-7AC24E807778")) IComponentEnum;

EXTERN_GUID(IID_IAudioPluginMgr, 0x3a7f0880, 0x85f4, 0x43c9, 0xb2, 0x1f, 0x48, 0x4c, 0x9a, 0xc6, 0x96, 0x8a);
struct __declspec(uuid("3A7F0880-85F4-43c9-B21F-484C9AC6968A")) IAudioPluginMgr;

EXTERN_GUID(IID_ILanguage, 0xfefb0cdf, 0xc033, 0x4bbc, 0x8a, 0xa, 0x9f, 0x11, 0x31, 0x88, 0xdb, 0x71);
struct __declspec(uuid("FEFB0CDF-C033-4bbc-8A0A-9F113188DB71")) ILanguage;

EXTERN_GUID(IID_IProfile, 0xc86f7224, 0x343c, 0x4577, 0xbf, 0x6d, 0x12, 0xfa, 0x51, 0x7a, 0xa, 0xa2);
struct __declspec(uuid("C86F7224-343C-4577-BF6D-12FA517A0AA2")) IProfile;

EXTERN_GUID(IID_ISeekable, 0xbec79707, 0x7bac, 0x415b, 0x9f, 0x90, 0x48, 0xf9, 0xd8, 0x75, 0xb4, 0xc);
struct __declspec(uuid("BEC79707-7BAC-415b-9F90-48F9D875B40C")) ISeekable;

EXTERN_GUID(IID_IAudioRawBlockInfo, 0xc29cd009, 0x7187, 0x498f, 0x8f, 0x7, 0x30, 0xe2, 0x2f, 0xee, 0x39, 0x2b);
struct __declspec(uuid("C29CD009-7187-498f-8F07-30E22FEE392B")) IAudioRawBlockInfo;

EXTERN_GUID(IID_IExtEnum, 0x243c1749, 0x490a, 0x492e, 0x8f, 0x84, 0x1, 0xc3, 0x2, 0xd1, 0x25, 0x2d);
struct __declspec(uuid("243C1749-490A-492e-8F84-01C302D1252D")) IExtEnum;

EXTERN_GUID(IID_IAudioRawWriter, 0xb011fb4d, 0x3a88, 0x4a32, 0xbc, 0xd6, 0xdb, 0xf0, 0xdd, 0xbf, 0xcf, 0xc0);
struct __declspec(uuid("B011FB4D-3A88-4a32-BCD6-DBF0DDBFCFC0")) IAudioRawWriter;

EXTERN_GUID(IID_IURLAudioTargetFactory, 0xbb980e93, 0x637f, 0x4373, 0x8f, 0x7d, 0xa8, 0xaa, 0x10, 0x3c, 0xa7, 0x32);
struct __declspec(uuid("BB980E93-637F-4373-8F7D-A8AA103CA732")) IURLAudioTargetFactory;

EXTERN_GUID(IID_IInfoReader, 0xd5741427, 0x89f9, 0x409b, 0x93, 0x49, 0x5b, 0x82, 0xe5, 0x20, 0x57, 0x1f);
struct __declspec(uuid("D5741427-89F9-409b-9349-5B82E520571F")) IInfoReader;

EXTERN_GUID(IID_IInfoWriter, 0xfb863baf, 0xab38, 0x4851, 0x8b, 0x61, 0x14, 0x2, 0xb2, 0x7d, 0x2f, 0xa4);
struct __declspec(uuid("FB863BAF-AB38-4851-8B61-1402B27D2FA4")) IInfoWriter;

EXTERN_GUID(IID_IControl, 0x593ddc3f, 0xfc03, 0x4f89, 0x9f, 0xca, 0x68, 0x95, 0x3, 0x9e, 0xb9, 0xb7);
struct __declspec(uuid("593DDC3F-FC03-4f89-9FCA-6895039EB9B7")) IControl;

EXTERN_GUID(IID_IItemAdvInfoCallback, 0x69f36458, 0x44a9, 0x4894, 0x91, 0x15, 0xb, 0xe7, 0xb0, 0x93, 0xd3, 0x80);
struct __declspec(uuid("69F36458-44A9-4894-9115-0BE7B093D380")) ISrcInfoCallback;

EXTERN_GUID(IID_ISrcInfoViewerEditor, 0xd3787698, 0xf154, 0x4c09, 0x9f, 0x19, 0xee, 0x43, 0xd0, 0xf1, 0xf4, 0xbe);
struct __declspec(uuid("D3787698-F154-4c09-9F19-EE43D0F1F4BE")) ISrcInfoViewerEditor;

EXTERN_GUID(IID_IRealtimePlaybackController, 0x8fdabfc3, 0x5fc4, 0x4d90, 0xbc, 0xfb, 0x74, 0x7a, 0x6, 0x27, 0x94, 0x41);
struct __declspec(uuid("8FDABFC3-5FC4-4d90-BCFB-747A06279441")) IRealtimePlaybackController;

EXTERN_GUID(IID_ISkin, 0xee6211bd, 0x1ac2, 0x485d, 0x81, 0x46, 0xb5, 0xf4, 0xb3, 0x1a, 0xea, 0x8b);
struct __declspec(uuid("EE6211BD-1AC2-485d-8146-B5F4B31AEA8B")) ISkin;

EXTERN_GUID(IID_IMainWnd, 0x6e74cf43, 0x8ff4, 0x11d5, 0xb7, 0xa5, 0x0, 0x50, 0xda, 0x51, 0xe6, 0xe);
struct __declspec(uuid("6E74CF43-8FF4-11d5-B7A5-0050DA51E60E")) IMainWnd;

EXTERN_GUID(IID_IConfigurable, 0xf50907a0, 0xc032, 0x4935, 0xa3, 0xe0, 0x83, 0x20, 0x3, 0xe4, 0x4f, 0x6);
struct __declspec(uuid("F50907A0-C032-4935-A3E0-832003E44F06")) IConfigurable;

EXTERN_GUID(IID_IDownloader, 0xd83b6937, 0xf179, 0x43ce, 0x9a, 0x24, 0x7a, 0xa1, 0x22, 0x10, 0xdb, 0xf4);
struct __declspec(uuid("D83B6937-F179-43ce-9A24-7AA12210DBF4")) IDownloader;

EXTERN_GUID(IID_IDownloadJob, 0xc637c8ab, 0xd8e6, 0x4fdd, 0x87, 0x42, 0x74, 0x2c, 0x7f, 0xb0, 0xf7, 0xd6);
struct __declspec(uuid("C637C8AB-D8E6-4fdd-8742-742C7FB0F7D6")) IDownloadJob;

EXTERN_GUID(IID_IAbortable, 0x89d2ce4c, 0x2a1e, 0x4ac3, 0xb2, 0xd5, 0x1, 0xf2, 0x56, 0xd5, 0xd0, 0x3b);
struct __declspec(uuid("89D2CE4C-2A1E-4ac3-B2D5-01F256D5D03B")) IAbortable;

EXTERN_GUID(IID_IExAudioInfo, 0x65dbc9b4, 0x8a5e, 0x4192, 0xa3, 0x9, 0xec, 0xdc, 0x94, 0xce, 0x3, 0x64);
struct __declspec(uuid("65DBC9B4-8A5E-4192-A309-ECDC94CE0364")) IExAudioInfo;

EXTERN_GUID(IID_ILimit, 0xc1c202f0, 0x33f4, 0x43be, 0xa4, 0xa2, 0x6, 0xae, 0x71, 0xaa, 0x41, 0x97);
struct __declspec(uuid("C1C202F0-33F4-43be-A4A2-06AE71AA4197")) ILimit;

EXTERN_GUID(IID_IIndexArray, 0x8f35fb99, 0x2152, 0x4606, 0x99, 0x51, 0x81, 0xb7, 0x38, 0xe0, 0xae, 0xd9);
struct __declspec(uuid("8F35FB99-2152-4606-9951-81B738E0AED9")) IIndexArray;

EXTERN_GUID(IID_IConvertorFactory2, 0xe4bca11f, 0x3166, 0x48a4, 0x9f, 0xda, 0xfb, 0x48, 0x95, 0xc9, 0x3c, 0xf);
struct __declspec(uuid("E4BCA11F-3166-48a4-9FDA-FB4895C93C0F")) IConvertorFactory2;

EXTERN_GUID(IID_ISourceStreamLength, 0x39a4f833, 0xe01e, 0x4758, 0xad, 0xb2, 0x60, 0x23, 0x4, 0x28, 0x9a, 0xb8);
struct __declspec(uuid("39A4F833-E01E-4758-ADB2-602304289AB8")) ISourceStreamLength;

EXTERN_GUID(IID_ITrackNumber, 0xb6062833, 0xece6, 0x4716, 0xa6, 0xec, 0xf9, 0x6a, 0x8, 0x5a, 0xac, 0x14);
struct __declspec(uuid("B6062833-ECE6-4716-A6EC-F96A085AAC14")) ITrackNumber;

EXTERN_GUID(IID_IVendorInfo, 0x1446d8c0, 0x3989, 0x4143, 0x86, 0xb4, 0xd5, 0x85, 0xa9, 0x6e, 0xf8, 0xae);
struct __declspec(uuid("1446D8C0-3989-4143-86B4-D585A96EF8AE")) IVendorInfo;

EXTERN_GUID(IID_IIdentifiable, 0x4b524062, 0xc262, 0x4df4, 0x9a, 0x78, 0xa4, 0x48, 0x98, 0xd7, 0x5f, 0x4c);
struct __declspec(uuid("4B524062-C262-4df4-9A78-A44898D75F4C")) IIdentifiable;

EXTERN_GUID(IID_IComponentOrderMgr, 0x37f0ed8e, 0x9545, 0x477c, 0xa3, 0xed, 0xcf, 0x1d, 0x29, 0xb5, 0xe3, 0xf3);
struct __declspec(uuid("37F0ED8E-9545-477c-A3ED-CF1D29B5E3F3")) IComponentOrderMgr;

#endif // _AUDIO_PLUGIN_ENV_IID_
