//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "CreatedAtRuntime_.h"
#include "VidGrab.hpp"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "VidGrab"
#pragma resource "*.dfm"

TForm1 *Form1;
TVideoGrabber *VideoGrabber;
bool VideoGrabberCreated;

//---------------------------------------------------------------------------

__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
   VideoGrabberCreated = false;
   ComboBox1->Items->Text = VideoDevices();
   ComboBox1->ItemIndex = 0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
   if (VideoGrabber == NULL) {

      VideoGrabber = new TVideoGrabber (this);
      VideoGrabber->Visible = CheckBox1->Checked;
      VideoGrabber->AutoRefreshPreview = true;

      VideoGrabber->OnChangeVideoDevice = OnChangeVideoDevice;
      VideoGrabber->OnFrameCaptureCompleted = OnFrameCaptureCompleted;
      VideoGrabber->OnResizeVideo = OnResizeVideo;

      VideoGrabber->VideoDevice = ComboBox1->ItemIndex;

      VideoGrabber->Left = 8;
      VideoGrabber->Top = 55;

      VideoGrabber->Parent = this;

      VideoGrabber->StartPreview();
      VideoGrabberCreated = true;
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
   if (VideoGrabberCreated) {
      VideoGrabber->CaptureFrameTo (fc_TBitmap);
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
   if (VideoGrabberCreated) {
      VideoGrabber->Free();
      VideoGrabberCreated = false;
      VideoGrabber = NULL;
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::OnChangeVideoDevice(TObject *Sender)
{
   Image1->Picture->Assign (NULL);

   ComboBox2->Clear();
   ComboBox2->Items->Text = ((TVideoGrabber*) Sender)->VideoSizes;
   ComboBox2->ItemIndex = ((TVideoGrabber*) Sender)->VideoSize;

   ComboBox3->Clear();
   ComboBox3->Items->Text = ((TVideoGrabber*) Sender)->VideoCrossbarInputs;
   ComboBox3->ItemIndex = ((TVideoGrabber*) Sender)->VideoCrossbarInput;

   Button4->Enabled = VideoGrabber->IsTVTunerAvailable;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::OnFrameCaptureCompleted(TObject *Sender,
      const TFrameData &FrameData, TFrameCaptureDest DestType,
      AnsiString FileName, bool Success)
{
   Image1->Left = ((TVideoGrabber*) (Sender))->Left + ((TVideoGrabber*) (Sender))->Width + 10;
   Image1->AutoSize = true;
   Image1->Picture->Bitmap->Handle = FrameData.Bitmap->Handle;
   FrameData.Bitmap->ReleaseHandle();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::OnResizeVideo(TObject *Sender, int SourceWidth, int SourceHeight)
{
   int NewWidth;

   Image1->Picture->Assign (NULL);
   Height = VideoGrabber->Top + VideoGrabber->Height + 80;
   Image1->Left = VideoGrabber->Left + VideoGrabber->Width + 20;
   Image1->Top = 55;
   Image1->Width = VideoGrabber->Width;
   Image1->Height = VideoGrabber->Height;
   NewWidth = Image1->Left + VideoGrabber->Width + 15;
   if (NewWidth < GroupBox1->Width + 20) {
      NewWidth = GroupBox1->Width + 20;
   }
   Width = NewWidth;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
   if (VideoGrabberCreated) {
      VideoGrabber->ShowDialog (dlg_TVTuner);
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComboBox1Change(TObject *Sender)
{
   if (VideoGrabberCreated) {
      VideoGrabber->VideoDevice =ComboBox1->ItemIndex;
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComboBox2Change(TObject *Sender)
{
   if (VideoGrabberCreated) {
      VideoGrabber->VideoSize =ComboBox2->ItemIndex;
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComboBox3Change(TObject *Sender)
{
   if (VideoGrabberCreated) {
      VideoGrabber->VideoCrossbarInput =ComboBox3->ItemIndex;
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{
   if (VideoGrabberCreated) {
      VideoGrabber->Visible = CheckBox1->Checked;
   }
}
//---------------------------------------------------------------------------

