//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "MainDemo_VideoQuality.h"
#include "MainDemo_CameraControl.h"
#include "MainDemo_DrawOverFrames.h"
#include "MainDemo_VideoControl.h"
#include "MainDemo_TVTuner.h"
#include "MainDemo_FrameCapture.h"

#include "MainDemo_.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "VidGrab"
#pragma resource "*.dfm"

TForm_MainDemo *Form_MainDemo;
TForm *SnapForm;
TImage *SnapImage;
TForm *TransparentForm;
TPanel *TransparentPanel;
int ThirdPartyFilterIndex;

const FreeHandMouseMax = 1000;
TRect FreeHandMouseDrawing[FreeHandMouseMax];
int iFreeHandMouseDrawing = 0;
bool FreeHandMouseDrawingEnabled = false;

__fastcall TForm_MainDemo::TForm_MainDemo(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall AssignListToComboBox (TComboBox* ComboBox, AnsiString List, int Index)
{
   ComboBox->Items->Text = List;
   if (ComboBox->Items->Count > 0) {
      ComboBox->ItemIndex = Index;
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::FormCreate(TObject *Sender)
{
   // - global TVideoGrabber properties, like the VideoDevices list, can be read from the FormCreate event
   // - parameters that depend of the current video device are set in the OnChangeVideoDevice event below
   // - parameters that depend of the current audio device are set in the OnChangeAudioDevice event below

   AssignListToComboBox (ComboBox2, VideoDevices(), 0);
   AssignListToComboBox (ComboBox3, AudioDevices(), 0);
   AssignListToComboBox (ComboBox5, AudioCompressors(), VideoGrabber1->AudioCompressor);
   AssignListToComboBox (ComboBox6, VideoCompressors(), VideoGrabber1->VideoCompressor);

   CheckBox1->Checked = VideoGrabber1->AVICaptureCanPause;
   CheckBox2->Checked = VideoGrabber1->Visible;
   CheckBox3->Checked = VideoGrabber1->AudioCapture;
   CheckBox4->Checked = VideoGrabber1->ColorKeyEnabled;
   CheckBox5->Checked = VideoGrabber1->AudioRendering;
   CheckBox7->Checked = VideoGrabber1->PreallocCapFileEnabled;
   CheckBox8->Checked = VideoGrabber1->AVIFormatOpenDML;
   CheckBox10->Checked = VideoGrabber1->ReducePreviewCPULoad;
   CheckBox15->Checked = VideoGrabber1->DVNativeInterleavedToAVI;

   Edit2->Text = VideoGrabber1->StoragePath;
   Edit3->Text = IntToStr (VideoGrabber1->PreallocCapFileSizeInMB);
   Edit8->Text = FloatToStr (VideoGrabber1->PlayerFrameRate);
   Edit11->Text = IntToStr (VideoGrabber1->PreviewZoomSize) + '%';

   RadioGroup1->ItemIndex = VideoGrabber1->CompressionType;
   RadioGroup3->ItemIndex = VideoGrabber1->CompressionMode;
   RadioGroup4->ItemIndex = VideoGrabber1->FrameGrabber;
   RadioGroup7->ItemIndex = VideoGrabber1->AutoFileName;

   UpDown1->Position = VideoGrabber1->PlayerFrameRate * 1000;
   UpDown2->Position = (short) VideoGrabber1->PlayerFastSeekSpeedRatio;

   Autorefreshpreview1->Checked = VideoGrabber1->AutoRefreshPreview;
   Autostartplayer1->Checked = VideoGrabber1->AutoStartPlayer;
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::VideoGrabber1ChangeVideoDevice(TObject *Sender)
{
   // from this event set the parameters that change when the current video capture device change

   EnableOrDisableOptions();
   ComboBox2->ItemIndex = VideoGrabber1->VideoDevice; // to be sure the index correspond to the current video device

   Edit1->Text = FloatToStr (VideoGrabber1->FrameRate);

   Form_TVTuner->RefreshTVSettings();

   AssignListToComboBox (ComboBox1, VideoGrabber1->VideoSizes, 0);
   AssignListToComboBox (ComboBox7, VideoGrabber1->VideoSubtypes, 0);
   AssignListToComboBox (ComboBox8, VideoGrabber1->AnalogVideoStandards, VideoGrabber1->AnalogVideoStandard);
   AssignListToComboBox (ComboBox9, VideoGrabber1->VideoCrossbarInputs, VideoGrabber1->VideoCrossbarInput);
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::VideoGrabber1ChangeAudioDevice               (TObject *Sender)
{
   // from this event set the parameters that change when the current audio capture device change

   AssignListToComboBox (ComboBox4, VideoGrabber1->AudioFormats, VideoGrabber1->AudioFormat);
   AssignListToComboBox (ComboBox10, VideoGrabber1->AudioInputs, VideoGrabber1->AudioInput);
   TrackBar3->Position = VideoGrabber1->AudioVolume;
   TrackBar4->Position = VideoGrabber1->AudioInputLevel;
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::EnableOrDisableOptions (void)
{
   // refresh the controls according to the TVideoGrabber's states

   CheckBox9->Checked = VideoGrabber1->VideoPortEnabled;
   CheckBox9->Enabled = VideoGrabber1->IsVideoPortAvailable;
   CheckBox12->Checked = VideoGrabber1->DVReduceFrameRate;
   CheckBox12->Enabled = VideoGrabber1->IsDigitalVideoIn;
   CheckBox14->Checked = VideoGrabber1->DVUseExternalAudio;
   CheckBox14->Enabled = VideoGrabber1->IsDigitalVideoIn;
   CheckBox15->Enabled = VideoGrabber1->IsDigitalVideoIn;

   Edit1->Enabled =  ! VideoGrabber1->IsDigitalVideoIn;
   Button12->Enabled = ! VideoGrabber1->IsDigitalVideoIn;

   SendVCRCommands1->Enabled = VideoGrabber1->IsVCRCommandAvailable;

   Button1->Enabled = VideoGrabber1->AVICaptureCanPause;
   Button3->Enabled = ! VideoGrabber1->IsDigitalVideoIn;
   Button5->Enabled = VideoGrabber1->FrameGrabber != fg_Disabled;
   Button11->Enabled = VideoGrabber1->IsCameraControlAvailable;
   Button13->Enabled = VideoGrabber1->IsVideoQualityAvailable;
   Button14->Enabled = VideoGrabber1->AVICaptureCanPause;
   Button25->Enabled = VideoGrabber1->FrameGrabber != fg_Disabled;
   Button26->Enabled = VideoGrabber1->IsVideoControlAvailable;
   Button27->Enabled = VideoGrabber1->IsTVTunerAvailable;

   ComboBox8->Enabled = VideoGrabber1->IsAnalogVideoDecoderAvailable;
   ComboBox9->Enabled = VideoGrabber1->IsVideoCrossbarAvailable;

   RadioGroup3->Enabled = true;
   RadioGroup1->Enabled = true;

   if (! VideoGrabber1->AudioCapture)  {
      RadioGroup1->ItemIndex = 0;
      RadioGroup1->Enabled = false;
   };


   if (Form_FrameCapture != NULL) {
      // frame capture - one shot
      Form_FrameCapture->Button23->Enabled = VideoGrabber1->FrameGrabber != fg_Disabled;
      Form_FrameCapture->Button21->Enabled = VideoGrabber1->FrameGrabber != fg_Disabled;
      Form_FrameCapture->Button24->Enabled = VideoGrabber1->FrameGrabber != fg_Disabled;
      Form_FrameCapture->CheckBox1->Enabled = VideoGrabber1->FrameGrabber != fg_Disabled;
      Form_FrameCapture->Edit12->Enabled = VideoGrabber1->FrameGrabber != fg_Disabled;

      // frame capture - burst mode
      Form_FrameCapture->Button5->Enabled = VideoGrabber1->FrameGrabber != fg_Disabled;
      Form_FrameCapture->Button6->Enabled = VideoGrabber1->FrameGrabber != fg_Disabled;
      Form_FrameCapture->Button7->Enabled = VideoGrabber1->FrameGrabber != fg_Disabled;
      Form_FrameCapture->Button19->Enabled = VideoGrabber1->FrameGrabber != fg_Disabled;
      Form_FrameCapture->Edit6->Enabled = VideoGrabber1->FrameGrabber != fg_Disabled;
      Form_FrameCapture->Edit9->Enabled = VideoGrabber1->FrameGrabber != fg_Disabled;
   }

   if (Form_DrawOverFrames != NULL) {
   // draw text over frames
      Form_DrawOverFrames->CheckBox6->Enabled = VideoGrabber1->FrameGrabber != fg_Disabled;
      Form_DrawOverFrames->CheckBox10->Enabled = VideoGrabber1->FrameGrabber != fg_Disabled;
      Form_DrawOverFrames->RadioGroup2->Enabled = VideoGrabber1->FrameGrabber != fg_Disabled;
      Form_DrawOverFrames->Memo2->Enabled = VideoGrabber1->FrameGrabber != fg_Disabled;
      Form_DrawOverFrames->Edit7->Enabled = VideoGrabber1->FrameGrabber != fg_Disabled;
      Form_DrawOverFrames->Edit14->Enabled = VideoGrabber1->FrameGrabber != fg_Disabled;
      Form_DrawOverFrames->Edit15->Enabled = VideoGrabber1->FrameGrabber != fg_Disabled;

      // draw shape over frames
      Form_DrawOverFrames->CheckBox11->Enabled = VideoGrabber1->FrameGrabber != fg_Disabled;
      Form_DrawOverFrames->Edit16->Enabled = VideoGrabber1->FrameGrabber != fg_Disabled;
      Form_DrawOverFrames->Edit17->Enabled = VideoGrabber1->FrameGrabber != fg_Disabled;
      Form_DrawOverFrames->Edit18->Enabled = VideoGrabber1->FrameGrabber != fg_Disabled;
      Form_DrawOverFrames->Edit19->Enabled = VideoGrabber1->FrameGrabber != fg_Disabled;
   }

   if (Form_VideoControl != NULL) {
      Form_VideoControl->CheckBox1->Enabled = VideoGrabber1->IsVideoControlModeAvailable (vc_FlipHorizontal);
      Form_VideoControl->CheckBox2->Enabled = VideoGrabber1->IsVideoControlModeAvailable (vc_FlipVertical);
      Form_VideoControl->CheckBox3->Enabled = VideoGrabber1->IsVideoControlModeAvailable (vc_ExternalTriggerEnable);
      Form_VideoControl->CheckBox4->Enabled = VideoGrabber1->IsVideoControlModeAvailable (vc_Trigger);
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::VideoGrabber1CaptureReadyToStart(TObject *Sender, bool &OkToStart)
{
   if (MessageDlg ("Ready to start capture!", mtInformation, TMsgDlgButtons() << mbOK << mbCancel, 0) == mrOk ) {
      OkToStart = true;
   }
   else {
      OkToStart = false;
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::VideoGrabber1CaptureStarted(TObject *Sender)
{
   Memo1->Lines->Add ("capturing " + IntToStr (VideoGrabber1->AVICaptureWidth) + " " + IntToStr (VideoGrabber1->AVICaptureHeight));
   Memo1->Lines->Add ("current frame rate: " + FormatFloat ("0.00", Extended (VideoGrabber1->CurrentFrameRate)) + " fps.");
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::VideoGrabber1DeviceLost(TObject *Sender)
{
   Memo1->Lines->Add ("DEVICE LOST!");
   AssignListToComboBox (ComboBox2, VideoDevices(), VideoGrabber1->VideoDevice);
   AssignListToComboBox (ComboBox3, AudioDevices(), VideoGrabber1->AudioDevice);
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::VideoGrabber1DiskFull(TObject *Sender)
{
   Memo1->Lines->Add ("DISK FULL!");
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::VideoGrabber1RecompressStarted(TObject *Sender)
{
   Memo1->Lines->Add ("recompressing...");
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::VideoGrabber1RecompressCompleted(TObject *Sender, bool Success)
{
   if (Success) {
      Memo1->Lines->Add ("recompression successful.");
   }
   else {
      Memo1->Lines->Add ("recompression failed.");
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::VideoGrabber1PreviewStarted(TObject *Sender)
{
   Memo1->Lines->Add (" video size " + IntToStr (VideoGrabber1->VideoWidth) + " " + IntToStr (VideoGrabber1->VideoHeight));
   Memo1->Lines->Add ("display size " + IntToStr (VideoGrabber1->DisplayWidth) + " " + IntToStr (VideoGrabber1->DisplayHeight));
   Memo1->Lines->Add ("current frame rate: " + FormatFloat ("0.00", Extended (VideoGrabber1->CurrentFrameRate)) + " fps.");
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::VideoGrabber1CopyPreallocDataStarted(TObject *Sender)
{
   Memo1->Lines->Add ("copying data from preallocated file...");
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::VideoGrabber1CopyPreallocDataCompleted(TObject *Sender, bool Success)
{
   if (Success) {
      Memo1->Lines->Add ("preallocated file copy successful.");
   }
   else {
      Memo1->Lines->Add ("preallocated file copy failed.");
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::VideoGrabber1CreatePreallocFileStarted(TObject *Sender)
{
   Memo1->Lines->Add ("creating prealloc file...");
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::VideoGrabber1CreatePreallocFileCompleted(TObject *Sender, bool Success)
{
   if (Success) {
      Memo1->Lines->Add ("preallocated file successfully created.");
   }
   else {
      Memo1->Lines->Add ("creation of preallocated file failed.");
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::VideoGrabber1CaptureCompleted(TObject *Sender,
      AnsiString FileName, bool Success)
{
   if (Success) {
      Memo1->Lines->Add ("capture successful.");
   }
   else {
      Memo1->Lines->Add ("capture failed.");
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::VideoGrabber1FrameCaptureCompleted(TObject *Sender,
      const TFrameData &FrameData, TFrameCaptureDest DestType,
      AnsiString FileName, bool Success)
{
   TForm *DestForm;
   TImage *DestImage;

   if (Success) {
      Form_FrameCapture->Memo1->Lines->Add ("frame #" + IntToStr (FrameData.FrameNumber) + " captured");
   }

   // ______ bmp || jpeg file
   if ((DestType == fc_BmpFile) || (DestType == fc_JpegFile)) {
      if (Success) {
          Form_FrameCapture->Memo1->Lines->Add (FileName);
       }
       else {
          Form_FrameCapture->Memo1->Lines->Add ("error: failed to create " + FileName);
       }
   }
   // ______ memory bitmap
   else if (DestType == fc_TBitmap) {
      if ((! VideoGrabber1->BurstMode) || (VideoGrabber1->BurstMode && (VideoGrabber1->BurstCount == 0)) ) { // reuse the same form
         if (SnapForm == NULL) {
            Application->CreateForm (__classid (TForm), &SnapForm);
            SnapForm->Position = poDefault;
            SnapForm->FormStyle = fsStayOnTop;
         }
         if (SnapImage != NULL) {
            SnapImage->Free();
         }
         SnapImage = new TImage (NULL);
         DestForm = SnapForm;
         DestImage = SnapImage;
      }
      else { // create a form for each image
         Application->CreateForm (__classid (TForm), &DestForm);
         DestForm->Position = poDefault;
         DestForm->FormStyle = fsStayOnTop;
         DestImage = new TImage (DestForm);
         DestImage->Parent = DestForm;
      }

      DestForm->ClientWidth = FrameData.Bitmap->Width;
      DestForm->ClientHeight = FrameData.Bitmap->Height;
      DestImage->AutoSize = true;

      DestImage->Picture->Bitmap->Assign (FrameData.Bitmap);
      // REPLACING THE STATEMENT ABOVE BY THE 2 STATEMENTS BELOW IS FASTER (AVOIDS BITMAP COPY)
      // DestImage->Picture->Bitmap->Handle := FrameData.Bitmap->Handle;
      // FrameData.Bitmap->ReleaseHandle;

      DestImage->Parent = DestForm;

      if (! DestForm->Visible ) {
         DestForm->Show();
      }
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::VideoGrabber1FrameProgress(TObject *Sender,
      const TFrameInfo &FrameInfo)
{
   TVarRec SampleTimeVars[] = {FrameInfo.SampleTime_Hour, FrameInfo.SampleTime_Min, FrameInfo.SampleTime_Sec, FrameInfo.SampleTime_Hs};

   Edit4->Text = "frame: " + IntToStr (FrameInfo.FrameNumber)
               + " dropped:" + IntToStr (FrameInfo.DroppedFrameCount)
               + " time:" + Format ("%.2d:%.2d:%.2d %.2d", SampleTimeVars, (ARRAYSIZE(SampleTimeVars) - 1));

   if (FrameInfo.TimeCode_Sec == -1)  {
       Edit10->Text = "                     - - : - - : - -   - -";
   }
   else {
       TVarRec TimeCodeVars[] = {FrameInfo.TimeCode_Hour, FrameInfo.TimeCode_Min, FrameInfo.TimeCode_Sec, FrameInfo.TimeCode_Ff};
       Edit10->Text = Format ("                     %.2d:%.2d:%.2d %.2d", TimeCodeVars, (ARRAYSIZE(TimeCodeVars) - 1));
   }
   if (VideoGrabber1->CurrentState == cs_Player) {
      TrackBar1->Position = (int) VideoGrabber1->PlayerFramePosition;
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::VideoGrabber1DrawOverFrame(TObject *Sender,
      const TFrameInfo &FrameInfo, HDC Dc)
{
   int BitmapZoomedWidth, BitmapZoomedHeight;

   if (Form_DrawOverFrames->CheckBox1->Checked) {
      if (Form_DrawOverFrames->TrackBar1->Position == 100) { // faster if we do not have to resize the bitmap
         BitmapZoomedWidth = Form_DrawOverFrames->Image1->Picture->Bitmap->Width;
         BitmapZoomedHeight = Form_DrawOverFrames->Image1->Picture->Bitmap->Height;
      }
      else {
         BitmapZoomedWidth  = Form_DrawOverFrames->Image1->Picture->Bitmap->Width * Form_DrawOverFrames->TrackBar1->Position / 100;
         BitmapZoomedHeight = Form_DrawOverFrames->Image1->Picture->Bitmap->Height * Form_DrawOverFrames->TrackBar1->Position / 100;
      }
      VideoGrabber1->DrawBitmapOverFrame (Form_DrawOverFrames->Image1->Picture->Bitmap, 10, 100, BitmapZoomedWidth, BitmapZoomedHeight);
   }

   if (iFreeHandMouseDrawing > 0) { // see VideoGrabber1MouseMove event below
      TCanvas *Canvas = new (TCanvas);
      Canvas->Handle = Dc;
      Canvas->Pen->Color = clRed;
      for (int i = 0; i < iFreeHandMouseDrawing ; i ++) {
         if (FreeHandMouseDrawing[i].Right == 0) { // Right is used as boolean to know if it is a MoveTo or a LineTo
            Canvas->MoveTo (FreeHandMouseDrawing[i].Left, FreeHandMouseDrawing[i].Top);
            Canvas->Pixels[FreeHandMouseDrawing[i].Left][FreeHandMouseDrawing[i].Top] = clRed;
         }
         else {
            Canvas->LineTo (FreeHandMouseDrawing[i].Left, FreeHandMouseDrawing[i].Top);
         }
      }
      delete (Canvas);
   }
}

//---------------------------------------------------------------------------
void __fastcall TForm_MainDemo::VideoGrabber1MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
   if (FreeHandMouseDrawingEnabled) {
      if (iFreeHandMouseDrawing < FreeHandMouseMax) {
         FreeHandMouseDrawing[iFreeHandMouseDrawing].Left = X;
         FreeHandMouseDrawing[iFreeHandMouseDrawing].Top = Y;
         FreeHandMouseDrawing[iFreeHandMouseDrawing].Right = 1; // Right is used as boolean to know if it is a MoveTo or a LineTo in the VideoGrabber1DrawOverFrame event above
         iFreeHandMouseDrawing ++;
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm_MainDemo::VideoGrabber1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
   if (Form_DrawOverFrames->CheckBox2->Checked) {
      FreeHandMouseDrawing[iFreeHandMouseDrawing].Left = X;
      FreeHandMouseDrawing[iFreeHandMouseDrawing].Top = Y;
      FreeHandMouseDrawing[iFreeHandMouseDrawing].Right = 0; // Right is used as boolean to know if it is a MoveTo or a LineTo in the VideoGrabber1DrawOverFrame event above
      iFreeHandMouseDrawing ++;
      FreeHandMouseDrawingEnabled = True;
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm_MainDemo::VideoGrabber1MouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
   FreeHandMouseDrawingEnabled = False;
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::VideoGrabber1ResizeVideo(TObject *Sender, int SourceWidth, int SourceHeight)
{
   VideoGrabber1->TextOnFrame_Right = SourceWidth;
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::VideoGrabber1DeviceArrivalOrRemoval(
      TObject *Sender, bool IsDeviceArrival, bool IsVideoDevice,
      AnsiString DeviceName, int DeviceIndex)
{
   AnsiString AudioOrVideoDevice;

   if (IsVideoDevice) {
      AudioOrVideoDevice = "video device ";
   }
   else {
      AudioOrVideoDevice = "audio device ";
   }
   if (IsDeviceArrival) {
      Memo1->Lines->Add (AudioOrVideoDevice + "arrival:");
   }
   else {
      Memo1->Lines->Add (AudioOrVideoDevice + "removal:");
   }
   Memo1->Lines->Add (DeviceName);
   if (IsVideoDevice) {
      AssignListToComboBox (ComboBox2, VideoDevices(), VideoGrabber1->VideoDevice);
   }
   else {
      AssignListToComboBox (ComboBox3, AudioDevices(), VideoGrabber1->AudioDevice);
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::VideoGrabber1TVTuningChannel(TObject *Sender,
      int Channel, bool Success, bool IsWeak, int VideoFrequency,
      int AudioFrequency)
{
   AnsiString ChannelInfo;

   ChannelInfo = IntToStr (Channel);
   if (Success) {
      if (VideoGrabber1->TVAutoTuneWeakChannels) {
         if (IsWeak) {
            ChannelInfo = ChannelInfo + "(-)"; // the signal is weak
         }
         else {
            ChannelInfo = ChannelInfo + "(+)"; // good signal strength
         }
      }
      ChannelInfo = ChannelInfo + ": " + IntToStr (VideoFrequency / 1000000) + " Mhz";
   }
   else {
      ChannelInfo = ChannelInfo + "...";
   }
   Form_TVTuner->Memo1->Lines->Add (ChannelInfo);

}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::VideoGrabber1TVTuningCompleted(TObject *Sender,
      bool Success)
{
   if (Success) {
      Form_TVTuner->Memo1->Lines->Add ("done.");
   }
   else {
      Form_TVTuner->Memo1->Lines->Add ("cancelled.");
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::VideoGrabber1PlayerStarted(TObject *Sender)
{
   TrackBar1->Min = 1;
   TrackBar1->Frequency = 1;
   TrackBar1->PageSize = 1;
   TrackBar1->Max = (int) VideoGrabber1->PlayerFrameCount;

   Memo1->Lines->Add ("Duration: " + FormatFloat ("0.00", Extended (VideoGrabber1->PlayerDuration) / 10000000));
   Memo1->Lines->Add ("Frame Count: " + IntToStr (VideoGrabber1->PlayerFrameCount));
   Memo1->Lines->Add ("Frame rate: " + FormatFloat ("0.00", VideoGrabber1->PlayerFrameRate));
   Memo1->Lines->Add ("size:" + IntToStr (VideoGrabber1->VideoWidth) + "x" + IntToStr (VideoGrabber1->VideoHeight));

   Memo1->Lines->Add ("playing " + VideoGrabber1->PlayerFileName);
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::VideoGrabber1PlayerEndOfStream(TObject *Sender)
{
   Memo1->Lines->Add ("} of stream.");
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::VideoGrabber1PlayerFileNotFound(TObject *Sender,
      AnsiString FileName)
{
   Memo1->Lines->Add ("file ! found: " + FileName);
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::VideoGrabber1ErrorLog(TObject *Sender,
      TErrorType ErrorType, AnsiString Severity, AnsiString ErrorMsg)
{
   Memo1->Lines->Add ("[" + Severity + "] " + ErrorMsg);
}
//---------------------------------------------------------------------------
void __fastcall TForm_MainDemo::SendVCRCommand(TObject *Sender)
{
   if (VideoGrabber1->SendVCRCommand (TVCRCommand (((TMenuItem*) Sender)->Tag))) {
      Memo1->Lines->Add ("VCR command successful.");
   }
   else {
      Memo1->Lines->Add ("VCR command failed.");
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::Button17Click(TObject *Sender)
{
   VideoGrabber1->StartAVICapture();
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::Button14Click(TObject *Sender)
{
   VideoGrabber1->PauseAVICapture();
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::Button1Click(TObject *Sender)
{
   VideoGrabber1->ResumeAVICapture();
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::Button2Click(TObject *Sender)
{
   VideoGrabber1->StopAVICapture();
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::Button3Click(TObject *Sender)
{
   // WARNING: USUALLY, THIS DIALOG ALLOWS TO CHANGE ONLY 1 PARAMETER AT THE SAME TIME

   VideoGrabber1->ShowDialog (dlg_StreamConfig);

   Edit1->Text = FloatToStr (VideoGrabber1->FrameRate);
   ComboBox1->ItemIndex = VideoGrabber1->VideoSize;
   ComboBox7->ItemIndex = VideoGrabber1->VideoSubtype;
   // now the frame rate, video size && video sub type match the current settings,
   // if any changed in the dialog
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::Button4Click(TObject *Sender)
{
   VideoGrabber1->ShowDialog(dlg_Compressor);
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::Button8Click(TObject *Sender)
{
   VideoGrabber1->StopPreview();
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::Button9Click(TObject *Sender)
{
   VideoGrabber1->StartPreview();
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::Button10Click(TObject *Sender)
{
   VideoGrabber1->ShowDialog(dlg_Device);

   ComboBox8->ItemIndex = int (VideoGrabber1->AnalogVideoStandard);
   // to make AnalogVideoStandard match the current setting, if modified in the dialog
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::Button11Click(TObject *Sender)
{
   ShowFormAboveVideo (Form_CameraControl);
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::Button13Click(TObject *Sender)
{
   ShowFormAboveVideo (Form_VideoQuality);
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::Button25Click(TObject *Sender)
{
   ShowFormAboveVideo (Form_DrawOverFrames);
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::Button26Click(TObject *Sender)
{
   ShowFormAboveVideo (Form_VideoControl);
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::Button27Click(TObject *Sender)
{
   ShowFormAboveVideo (Form_TVTuner);
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::Button5Click(TObject *Sender)
{
   ShowFormAboveVideo (Form_FrameCapture);
}
//---------------------------------------------------------------------------
void __fastcall TForm_MainDemo::Button12Click(TObject *Sender)
{
   Double Value;

   Value = StrToFloatDef (Edit1->Text, -1);
   if (Value != -1) {
      VideoGrabber1->FrameRate = Value;
      if (VideoGrabber1->CurrentState == cs_Preview) {
         Memo1->Lines->Add ("current frame rate: " + FormatFloat ("0.00", VideoGrabber1->CurrentFrameRate) + " fps.");
      }
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::Button16Click(TObject *Sender)
{
   VideoGrabber1->ClosePlayer();
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::Button18Click(TObject *Sender)
{
   TrackBar2->Position = 100;
   TrackBar2Change (TrackBar2);
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::Button22Click(TObject *Sender)
{
   VideoGrabber1->FullScreenPreview = true;
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::RadioGroup1Click(TObject *Sender)
{
   VideoGrabber1->CompressionType = TCompressionType (RadioGroup1->ItemIndex);
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::RadioGroup3Click(TObject *Sender)
{
   VideoGrabber1->CompressionMode = TCompressionMode (RadioGroup3->ItemIndex);
   EnableOrDisableOptions();
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::RadioGroup4Click(TObject *Sender)
{
   VideoGrabber1->FrameGrabber = TFrameGrabber (RadioGroup4->ItemIndex);
   EnableOrDisableOptions();
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::RadioGroup7Click(TObject *Sender)
{
   VideoGrabber1->AutoFileName = TAutoFileName (RadioGroup7->ItemIndex);
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::Edit2Change(TObject *Sender)
{
   VideoGrabber1->StoragePath = Edit2->Text;
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::Edit3Change(TObject *Sender)
{
   VideoGrabber1->PreallocCapFileSizeInMB = StrToIntDef (Edit3->Text, 100);
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::CheckBox1Click(TObject *Sender)
{
   VideoGrabber1->AVICaptureCanPause = CheckBox1->Checked;
   EnableOrDisableOptions();
}
//---------------------------------------------------------------------------
void __fastcall TForm_MainDemo::CheckBox2Click(TObject *Sender)
{
   VideoGrabber1->Visible = CheckBox2->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::CheckBox3Click(TObject *Sender)
{
   VideoGrabber1->AudioCapture = CheckBox3->Checked;
   EnableOrDisableOptions();
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::CheckBox4Click(TObject *Sender)
{
   // in this sample the transparent window is created in the OnColorKeyChange event below when the color key is set
   VideoGrabber1->ColorKeyEnabled = CheckBox4->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::VideoGrabber1ColorKeyChange(TObject *Sender,
      TColor ColorKey)
{
   if (! TransparentForm) {
      Application->CreateForm (__classid (TForm), &TransparentForm);
      TransparentForm->Width = 300;
      TransparentForm->Height = 100;
      TransparentForm->Position = poScreenCenter;
      TransparentForm->FormStyle = fsStayOnTop;
      TransparentPanel = new TPanel (TransparentForm);
      TransparentPanel->Parent = TransparentForm;
      TransparentPanel->BevelInner = bvNone;
      TransparentPanel->BevelOuter = bvNone;
      TransparentPanel->Align = alClient;
      TransparentPanel->Caption = "transparent window";
      TransparentPanel->Font->Color = clRed;
      TransparentPanel->Font->Size = 16;
   };

   TransparentForm->Color = ColorKey;
   TransparentPanel->Color = ColorKey;

   TransparentForm->Show();
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::CheckBox5Click(TObject *Sender)
{
   VideoGrabber1->AudioRendering = CheckBox5->Checked;
   EnableOrDisableOptions();
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::CheckBox7Click(TObject *Sender)
{
   VideoGrabber1->PreallocCapFileEnabled = CheckBox7->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::CheckBox8Click(TObject *Sender)
{
   VideoGrabber1->AVIFormatOpenDML = CheckBox8->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::CheckBox9Click(TObject *Sender)
{
   VideoGrabber1->VideoPortEnabled = CheckBox9->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::CheckBox10Click(TObject *Sender)
{
   VideoGrabber1->ReducePreviewCPULoad = CheckBox10->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::CheckBox12Click(TObject *Sender)
{
   VideoGrabber1->DVReduceFrameRate = CheckBox12->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::CheckBox14Click(TObject *Sender)
{
   VideoGrabber1->DVUseExternalAudio = CheckBox14->Checked;
   EnableOrDisableOptions();
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::CheckBox15Click(TObject *Sender)
{
   VideoGrabber1->DVNativeInterleavedToAVI = CheckBox15->Checked;
   EnableOrDisableOptions();
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::ComboBox1Change(TObject *Sender)
{
   VideoGrabber1->VideoSize = ComboBox1->ItemIndex;
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::ComboBox2Change(TObject *Sender)
{
   VideoGrabber1->VideoDevice = ComboBox2->ItemIndex;
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::ComboBox3Change(TObject *Sender)
{
   VideoGrabber1->AudioDevice = ComboBox3->ItemIndex;
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::ComboBox4Change(TObject *Sender)
{
   VideoGrabber1->AudioFormat = TAudioFormat (ComboBox4->ItemIndex);
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::ComboBox5Change(TObject *Sender)
{
   VideoGrabber1->AudioCompressor = ComboBox5->ItemIndex;
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::ComboBox6Change(TObject *Sender)
{
   VideoGrabber1->VideoCompressor = ComboBox6->ItemIndex;
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::ComboBox7Change(TObject *Sender)
{
   VideoGrabber1->VideoSubtype = ComboBox7->ItemIndex;
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::ComboBox8Change(TObject *Sender)
{
   VideoGrabber1->AnalogVideoStandard = ComboBox8->ItemIndex;
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::ComboBox9Change(TObject *Sender)
{
   VideoGrabber1->VideoCrossbarInput = ComboBox9->ItemIndex;
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::ComboBox10Change(TObject *Sender)
{
   VideoGrabber1->AudioInput = ComboBox10->ItemIndex;
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::UpDown1Click(TObject *Sender, TUDBtnType Button)
{
   VideoGrabber1->PlayerSpeedRatio = Extended (UpDown1->Position) / 1000;
   Edit8->Text = FormatFloat("0.0", VideoGrabber1->PlayerFrameRate);
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::UpDown2Click(TObject *Sender, TUDBtnType Button)
{
   VideoGrabber1->PlayerFastSeekSpeedRatio = UpDown2->Position;
   Edit21->Text = IntToStr (VideoGrabber1->PlayerFastSeekSpeedRatio);
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::SpeedButton1Click(TObject *Sender)
{
   OpenDialog1->FileName = "*.mpg;*.mpeg;*.avi;*.wav;*.mp3;*.asf;*.wmv";
   if (OpenDialog1->Execute()) {
      VideoGrabber1->PlayerFileName = OpenDialog1->FileName;
      VideoGrabber1->OpenPlayer();
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::SpeedButton2Click(TObject *Sender)
{
   VideoGrabber1->PausePlayer();
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::SpeedButton3Click(TObject *Sender)
{
   VideoGrabber1->StopPlayer();
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::SpeedButton4Click(TObject *Sender)
{
   VideoGrabber1->RunPlayer();
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::SpeedButton5Click(TObject *Sender)
{
   VideoGrabber1->RewindsPlayer();
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::SpeedButton6Click(TObject *Sender)
{
   VideoGrabber1->FastForwardsPlayer();
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::SpeedButton7Click(TObject *Sender)
{
   if (VideoGrabber1->Last_AVICapture_FileName != "") {
      VideoGrabber1->PlayerFileName = VideoGrabber1->Last_AVICapture_FileName;
      VideoGrabber1->OpenPlayer();
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::SpeedButton8Click(TObject *Sender)
{
   VideoGrabber1->RunPlayerBackwards();
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::TrackBar1Change(TObject *Sender)
{
   if (!  VideoGrabber1->InFrameProgressEvent) { // to avoid loopback troubles if TrackBar1.Position is set from the FrameProgess event
      VideoGrabber1->PlayerFramePosition = TrackBar1->Position;
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::TrackBar2Change(TObject *Sender)
{
   VideoGrabber1->PreviewZoomSize = (unsigned short) TrackBar2->Position;
   Edit11->Text = IntToStr (VideoGrabber1->PreviewZoomSize) + "%";
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::TrackBar3Change(TObject *Sender)
{
   VideoGrabber1->AudioVolume = TrackBar3->Position;
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::TrackBar4Change(TObject *Sender)
{
   VideoGrabber1->AudioInputLevel = TrackBar4->Position;
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::Exit1Click(TObject *Sender)
{
   Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::Detachwindow1Click(TObject *Sender)
{
   VideoGrabber1->DetachVideoWindow (20, 20, "any name can be given to this window", true, true);
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::Attachwindow1Click(TObject *Sender)
{
   VideoGrabber1->AttachVideoWindow();
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::DSCALERAddtolist1Click(TObject *Sender)
{
   // this demonstrates the use of the DSCALER deinterlacer. The filter can be downloaded from the following URL:

   // you have to know the CLSID of the third-party filter you want to use,
   // look at the user guide, chapter about "Third-party filters" to know how to retrieve it.

   static const GUID CLSID_DSCALER = {0x463D645D, 0x48F7, 0x11D4, { 0x84,0x64,0x00,0x08,0xC7,0x82,0xA2,0x57} };

   ThirdPartyFilterIndex = VideoGrabber1->ThirdPartyFilter_AddToList (tpf_VideoSource, CLSID_DSCALER, "DSCALER deinterlacer", true, true);
   if (ThirdPartyFilterIndex != -1)  {
      DSCALERAddtolist1->Enabled = false;
      DSCALERShowDialog1->Enabled = true;
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::DSCALERShowDialog1Click(TObject *Sender)
{
   VideoGrabber1->ThirdPartyFilter_ShowDialog (tpf_VideoSource, ThirdPartyFilterIndex);
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::DSCALERClearList1Click(TObject *Sender)
{
   VideoGrabber1->ThirdPartyFilter_ClearList (tpf_VideoSource);
   DSCALERAddtolist1->Enabled = true;
   DSCALERShowDialog1->Enabled = false;
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::About1Click(TObject *Sender)
{
   VideoGrabber1->About();
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::RadioGroup2Click(TObject *Sender)
{
   switch (RadioGroup2->ItemIndex) {
      case 0: VideoGrabber1->UseNearestVideoSize (0, 0, CheckBox6->Checked); break;
      case 1: VideoGrabber1->UseNearestVideoSize (80, 60, CheckBox6->Checked); break;
      case 2: VideoGrabber1->UseNearestVideoSize (160, 120, CheckBox6->Checked); break;
      case 3: VideoGrabber1->UseNearestVideoSize (320, 240, CheckBox6->Checked); break;
      case 4: VideoGrabber1->UseNearestVideoSize (352, 288, CheckBox6->Checked); break;
      case 5: VideoGrabber1->UseNearestVideoSize (640, 480, CheckBox6->Checked); break;
      case 6: VideoGrabber1->UseNearestVideoSize (720, 576, CheckBox6->Checked); break;
   }
   ComboBox1->Enabled = RadioGroup2->ItemIndex == 0;
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::CheckBox6Click(TObject *Sender)
{
   RadioGroup2Click (this);
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::ShowFormAboveVideo (TForm *Form)
{
   if (Form == NULL) return;
   Form->Top = Top + VideoGrabber1->Top - Form->Height;
   Form->Left = Left + VideoGrabber1->Left - Form->Width;
   if (Form->Top < 0) {
      Form->Top = 0;
   }
   if (Form->Left < 0) {
      Form->Left = 0;
   }
   Form->Show();
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::Autorefreshpreview1Click(TObject *Sender)
{
   Autorefreshpreview1->Checked = ! Autorefreshpreview1->Checked;
   VideoGrabber1->AutoRefreshPreview = Autorefreshpreview1->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TForm_MainDemo::Autostartplayer1Click(TObject *Sender)
{
   Autostartplayer1->Checked = ! Autostartplayer1->Checked;
   VideoGrabber1->AutoStartPlayer = Autostartplayer1->Checked;
}
//---------------------------------------------------------------------------


