#include <vcl.h>
#pragma hdrstop

#include "MainDemo_CameraControl.h"
#include "MainDemo_.h"
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm_CameraControl *Form_CameraControl;

__fastcall TForm_CameraControl::TForm_CameraControl(TComponent* Owner) : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm_CameraControl::InitTrackBar (TTrackBar *TrackBar, TCameraControl Setting, BOOL ResetToDefault, BOOL Reversed)
{
   if (Reversed ) {
      TrackBar->Tag = - int (Setting) - 1;
   }
   else {
      TrackBar->Tag = int (Setting) + 1;
   }
   if (! Form_MainDemo->VideoGrabber1->IsCameraControlSettingAvailable (Setting) ) {
      TrackBar->Enabled = False;
      TrackBar->Frequency = 0;
      TrackBar->Min = 0;
      TrackBar->Max = 1;
      if (! Reversed ) {
         TrackBar->Position = 0;
      }
      else {
         TrackBar->Position = 1;
      }
   }
   else {
      if (! ResetToDefault ) {
         CanUpdate = false;
      }
      TrackBar->Enabled = True;
      TrackBar->Min = Form_MainDemo->VideoGrabber1->CameraControlMin (Setting);
      TrackBar->Max = Form_MainDemo->VideoGrabber1->CameraControlMax (Setting);
      TrackBar->Frequency = Form_MainDemo->VideoGrabber1->CameraControlStep (Setting);
      if (ResetToDefault ) {
         if (! Reversed ) {
            TrackBar->Position = Form_MainDemo->VideoGrabber1->CameraControlDefault (Setting);
         }
         else {
            TrackBar->Position = TrackBar->Max - Form_MainDemo->VideoGrabber1->CameraControlDefault (Setting) + TrackBar->Min;
         }
      }
      else {
         if (! Reversed ) {
            TrackBar->Position = Form_MainDemo->VideoGrabber1->GetCameraControl (Setting);
         }
         else {
            TrackBar->Position = TrackBar->Max - Form_MainDemo->VideoGrabber1->GetCameraControl (Setting) + TrackBar->Min;
         }
      }
      TrackBar->Enabled = ! CheckBox1->Checked;
   }
   CanUpdate = True;
}
//---------------------------------------------------------------------------

void __fastcall TForm_CameraControl::InitTrackBars (BOOL ResetToDefault)
{
   InitTrackBar (TrackBar1, cc_Pan,      ResetToDefault, true);
   InitTrackBar (TrackBar2, cc_Tilt,     ResetToDefault, true);
   InitTrackBar (TrackBar3, cc_Roll,     ResetToDefault, true);
   InitTrackBar (TrackBar4, cc_Zoom,     ResetToDefault, true);
   InitTrackBar (TrackBar5, cc_Exposure, ResetToDefault, true);
   InitTrackBar (TrackBar6, cc_Iris,     ResetToDefault, true);
   InitTrackBar (TrackBar7, cc_Focus,    ResetToDefault, true);
}
//---------------------------------------------------------------------------

void __fastcall TForm_CameraControl::FormShow(TObject *Sender)
{
   CheckBox1->Checked = Form_MainDemo->VideoGrabber1->CameraControlAuto;
   InitTrackBars (False);
}
//---------------------------------------------------------------------------

void __fastcall TForm_CameraControl::OnTrackBarClick (TObject *Sender)
{
   int Selector;
   BOOL Reversed;
   TTrackBar *TrackBar;

   if (CanUpdate) {
      TrackBar = (TTrackBar*) Sender;
      Selector = TrackBar->Tag;
      if (Selector < 0 ) {
         Selector = - Selector;
         Reversed = True;
      }
      else {
         Reversed = False;
      }
      Selector --;
      if (! Reversed ) {
         Form_MainDemo->VideoGrabber1->SetCameraControl (TCameraControl (Selector), TrackBar->Position);
      }
      else {
         Form_MainDemo->VideoGrabber1->SetCameraControl (TCameraControl (Selector), TrackBar->Max - TrackBar->Position + TrackBar->Min);
      }
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm_CameraControl::CheckBox1Click(TObject *Sender)
{
   Button1->Enabled = ! CheckBox1->Checked;
   Form_MainDemo->VideoGrabber1->CameraControlAuto = CheckBox1->Checked;
   InitTrackBars (False);
}
//---------------------------------------------------------------------------

void __fastcall TForm_CameraControl::Button1Click(TObject *Sender)
{
   InitTrackBars (True);
}
//---------------------------------------------------------------------------

void __fastcall TForm_CameraControl::Button2Click(TObject *Sender)
{
   Close();
}
//---------------------------------------------------------------------------



