unit MainDemo_CameraControl;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, VidGrab;

type
  TForm_CameraControl = class(TForm)
    TrackBar2: TTrackBar;
    TrackBar1: TTrackBar;
    TrackBar3: TTrackBar;
    TrackBar4: TTrackBar;
    TrackBar5: TTrackBar;
    TrackBar6: TTrackBar;
    TrackBar7: TTrackBar;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    CheckBox1: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure OnTrackBarClick (Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
  private
     CanUpdate: Boolean;
     procedure InitTrackBar (TrackBar: TTrackBar; Setting: TCameraControl; ResetToDefault, Reversed: Boolean);
  public
     procedure InitTrackBars (ResetToDefault: Boolean);
  end;

var
  Form_CameraControl: TForm_CameraControl;

implementation

uses MainDemo_;

{$R *.DFM}

procedure TForm_CameraControl.InitTrackBar (TrackBar: TTrackBar; Setting: TCameraControl; ResetToDefault: Boolean; Reversed: Boolean);
begin
   if Reversed then begin
      TrackBar.Tag := - integer (Setting) - 1;
   end
   else begin
      TrackBar.Tag := integer (Setting) + 1;
   end;
   if not Form_MainDemo.VideoGrabber1.IsCameraControlSettingAvailable (Setting) then begin
      TrackBar.Enabled := False;
      TrackBar.Frequency := 0;
      TrackBar.Min := 0;
      TrackBar.Max := 1;
      if not Reversed then begin
         TrackBar.Position := 0;
      end
      else begin
         TrackBar.Position := 1;
      end;
   end
   else begin
      if not ResetToDefault then begin
         CanUpdate := false;
      end;
      TrackBar.Enabled := True;
      TrackBar.Min := Form_MainDemo.VideoGrabber1.CameraControlMin (Setting);
      TrackBar.Max := Form_MainDemo.VideoGrabber1.CameraControlMax (Setting);
      TrackBar.Frequency := Form_MainDemo.VideoGrabber1.CameraControlStep (Setting);
      if ResetToDefault then begin
         if not Reversed then begin
            TrackBar.Position := Form_MainDemo.VideoGrabber1.CameraControlDefault (Setting);
         end
         else begin
            TrackBar.Position := TrackBar.Max - Form_MainDemo.VideoGrabber1.CameraControlDefault (Setting) + TrackBar.Min;
         end;
      end
      else begin
         if not Reversed then begin
            TrackBar.Position := Form_MainDemo.VideoGrabber1.GetCameraControl (Setting);
         end
         else begin
            TrackBar.Position := TrackBar.Max - Form_MainDemo.VideoGrabber1.GetCameraControl (Setting) + TrackBar.Min;
         end;
      end;
      TrackBar.Enabled := not CheckBox1.Checked;
   end;
   CanUpdate := True;
end;
//---------------------------------------------------------------------------

procedure TForm_CameraControl.InitTrackBars (ResetToDefault: Boolean);
begin
   InitTrackBar (TrackBar1, cc_Pan,      ResetToDefault, True);
   InitTrackBar (TrackBar2, cc_Tilt,     ResetToDefault, True);
   InitTrackBar (TrackBar3, cc_Roll,     ResetToDefault, True);
   InitTrackBar (TrackBar4, cc_Zoom,     ResetToDefault, True);
   InitTrackBar (TrackBar5, cc_Exposure, ResetToDefault, True);
   InitTrackBar (TrackBar6, cc_Iris,     ResetToDefault, True);
   InitTrackBar (TrackBar7, cc_Focus,    ResetToDefault, True);
end;
//---------------------------------------------------------------------------

procedure TForm_CameraControl.FormShow(Sender: TObject);
begin
   CheckBox1.Checked := Form_MainDemo.VideoGrabber1.CameraControlAuto;
   Form_CameraControl.InitTrackBars (False);
end;
//---------------------------------------------------------------------------

procedure TForm_CameraControl.OnTrackBarClick (Sender: TObject);
var
   Selector: integer;
   Reversed: Boolean;
begin
   if not CanUpdate then Exit;
   Selector := TTrackbar(Sender).Tag;
   if Selector < 0 then begin
      Selector := - Selector;
      Reversed := True;
   end
   else begin
      Reversed := False;
   end;
   Dec (Selector);
   if not Reversed then begin
      Form_MainDemo.VideoGrabber1.SetCameraControl (TCameraControl (Selector), TTrackbar (Sender).Position);
   end
   else begin
      Form_MainDemo.VideoGrabber1.SetCameraControl (TCameraControl (Selector), TTrackbar (Sender).Max - TTrackbar (Sender).Position + TTrackbar (Sender).Min);
   end;
end;
//---------------------------------------------------------------------------

procedure TForm_CameraControl.CheckBox1Click(Sender: TObject);
begin
   Button1.Enabled := not CheckBox1.Checked;
   Form_MainDemo.VideoGrabber1.CameraControlAuto := CheckBox1.Checked;
   InitTrackBars (False);
end;
//---------------------------------------------------------------------------

procedure TForm_CameraControl.Button1Click(Sender: TObject);
begin
   InitTrackBars (True);
end;
//---------------------------------------------------------------------------

procedure TForm_CameraControl.Button2Click(Sender: TObject);
begin
   Close;
end;
//---------------------------------------------------------------------------

end.
