#include <vcl.h>
#pragma hdrstop

#include "MainDemo_VideoQuality.h"
#include "MainDemo_.h"
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm_VideoQuality *Form_VideoQuality;
__fastcall TForm_VideoQuality::TForm_VideoQuality(TComponent* Owner) : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm_VideoQuality::InitTrackBar (TTrackBar *TrackBar, TVideoQuality Setting, BOOL ResetToDefault, BOOL Reversed)
{
   if (Reversed ) {
      TrackBar->Tag = - int (Setting) - 1;
   }
   else {
      TrackBar->Tag = int (Setting) + 1;
   }
   if (! Form_MainDemo->VideoGrabber1->IsVideoQualitySettingAvailable (Setting) ) {
      TrackBar->Enabled = False;
      TrackBar->Frequency = 0;
      TrackBar->Min = 0;
      TrackBar->Max = 1;
      if (! Reversed ) {
         TrackBar->Position = 0;
      }
      else {
         TrackBar->Position = 1;
      }
   }
   else {
      if (! ResetToDefault ) {
         CanUpdate = false;
      }
      TrackBar->Enabled = True;
      TrackBar->Min = Form_MainDemo->VideoGrabber1->VideoQualityMin (Setting);
      TrackBar->Max = Form_MainDemo->VideoGrabber1->VideoQualityMax (Setting);
      TrackBar->Frequency = Form_MainDemo->VideoGrabber1->VideoQualityStep (Setting);
      if (ResetToDefault ) {
         if (! Reversed ) {
            TrackBar->Position = Form_MainDemo->VideoGrabber1->VideoQualityDefault (Setting);
         }
         else {
            TrackBar->Position = TrackBar->Max - Form_MainDemo->VideoGrabber1->VideoQualityDefault (Setting) + TrackBar->Min;
         }
      }
      else {
         if (! Reversed ) {
            TrackBar->Position = Form_MainDemo->VideoGrabber1->GetVideoQuality (Setting);
         }
         else {
            TrackBar->Position = TrackBar->Max - Form_MainDemo->VideoGrabber1->GetVideoQuality (Setting) + TrackBar->Min;
         }
      }
      TrackBar->Enabled = ! CheckBox1->Checked;
   }
   CanUpdate = True;
}
//---------------------------------------------------------------------------

void __fastcall TForm_VideoQuality::InitTrackBars (BOOL ResetToDefault)
{
   InitTrackBar (TrackBar1, vq_Brightness, ResetToDefault, True);
   InitTrackBar (TrackBar2, vq_Contrast, ResetToDefault, True);
   InitTrackBar (TrackBar3, vq_Hue, ResetToDefault, True);
   InitTrackBar (TrackBar4, vq_Saturation, ResetToDefault, True);
   InitTrackBar (TrackBar5, vq_Sharpness, ResetToDefault, True);
   InitTrackBar (TrackBar6, vq_Gamma, ResetToDefault, True);
   InitTrackBar (TrackBar7, vq_WhiteBalance, ResetToDefault, True);
   InitTrackBar (TrackBar8, vq_Gain, ResetToDefault, True);
}
//---------------------------------------------------------------------------

void __fastcall TForm_VideoQuality::OnTrackBarClick (TObject *Sender)
{
   int Selector;
   BOOL Reversed;
   TTrackBar *TrackBar;

   if (CanUpdate) {
      TrackBar = (TTrackBar*) Sender;
      Selector = TrackBar->Tag;
      if (Selector < 0 ) {
         Selector = - Selector;
         Reversed = True;
      }
      else {
         Reversed = False;
      }
      Selector --;
      if (! Reversed ) {
         Form_MainDemo->VideoGrabber1->SetVideoQuality (TVideoQuality (Selector), TrackBar->Position);
      }
      else {
         Form_MainDemo->VideoGrabber1->SetVideoQuality (TVideoQuality (Selector), TrackBar->Max - TrackBar->Position + TrackBar->Min);
      }
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm_VideoQuality::FormShow(TObject *Sender)
{
   CheckBox1->Checked = Form_MainDemo->VideoGrabber1->VideoQualityAuto;
   InitTrackBars (False);
}
//---------------------------------------------------------------------------

void __fastcall TForm_VideoQuality::CheckBox1Click(TObject *Sender)
{
   Button1->Enabled = ! CheckBox1->Checked;
   Form_MainDemo->VideoGrabber1->VideoQualityAuto = CheckBox1->Checked;
   InitTrackBars (false);
}
//---------------------------------------------------------------------------

void __fastcall TForm_VideoQuality::Button1Click(TObject *Sender)
{
   InitTrackBars (True);
}
//---------------------------------------------------------------------------

void __fastcall TForm_VideoQuality::Button2Click(TObject *Sender)
{
   Close();
}
//---------------------------------------------------------------------------


