unit MainDemo_VideoQuality;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, VidGrab;

type
  TForm_VideoQuality = class(TForm)
    TrackBar2: TTrackBar;
    TrackBar1: TTrackBar;
    TrackBar3: TTrackBar;
    TrackBar4: TTrackBar;
    TrackBar5: TTrackBar;
    TrackBar6: TTrackBar;
    TrackBar7: TTrackBar;
    TrackBar8: TTrackBar;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    CheckBox1: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure OnTrackBarClick (Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
  private
     CanUpdate: Boolean;
     procedure InitTrackBar (TrackBar: TTrackBar; Setting: TVideoQuality; ResetToDefault, Reversed: Boolean);
  public
     procedure InitTrackBars (ResetToDefault: Boolean);
  end;

var
  Form_VideoQuality: TForm_VideoQuality;

implementation

uses MainDemo_;

{$R *.DFM}

procedure TForm_VideoQuality.InitTrackBar (TrackBar: TTrackBar; Setting: TVideoQuality; ResetToDefault: Boolean; Reversed: Boolean);

begin
   if Reversed then begin
      TrackBar.Tag := - integer (Setting) - 1;
   end
   else begin
      TrackBar.Tag := integer (Setting) + 1;
   end;
   if not Form_MainDemo.VideoGrabber1.IsVideoQualitySettingAvailable (Setting) then begin
      TrackBar.Enabled := False;
      TrackBar.Frequency := 0;
      TrackBar.Min := 0;
      TrackBar.Max := 1;
      if not Reversed then begin
         TrackBar.Position := 0;
      end
      else begin
         TrackBar.Position := 1;
      end;
   end
   else begin
      if not ResetToDefault then begin
         CanUpdate := false;
      end;
      TrackBar.Enabled := True;
      TrackBar.Min := Form_MainDemo.VideoGrabber1.VideoQualityMin (Setting);
      TrackBar.Max := Form_MainDemo.VideoGrabber1.VideoQualityMax (Setting);
      TrackBar.Frequency := Form_MainDemo.VideoGrabber1.VideoQualityStep (Setting);
      if ResetToDefault then begin
         if not Reversed then begin
            TrackBar.Position := Form_MainDemo.VideoGrabber1.VideoQualityDefault (Setting);
         end
         else begin
            TrackBar.Position := TrackBar.Max - Form_MainDemo.VideoGrabber1.VideoQualityDefault (Setting) + TrackBar.Min;
         end;
      end
      else begin
         if not Reversed then begin
            TrackBar.Position := Form_MainDemo.VideoGrabber1.GetVideoQuality (Setting);
         end
         else begin
            TrackBar.Position := TrackBar.Max - Form_MainDemo.VideoGrabber1.GetVideoQuality (Setting) + TrackBar.Min;
         end;
      end;
      TrackBar.Enabled := not CheckBox1.Checked;
   end;
   CanUpdate := True;
end;
//---------------------------------------------------------------------------

procedure TForm_VideoQuality.InitTrackBars (ResetToDefault: Boolean);
begin
   InitTrackBar (TrackBar1, vq_Brightness, ResetToDefault, True);
   InitTrackBar (TrackBar2, vq_Contrast, ResetToDefault, True);
   InitTrackBar (TrackBar3, vq_Hue, ResetToDefault, True);
   InitTrackBar (TrackBar4, vq_Saturation, ResetToDefault, True);
   InitTrackBar (TrackBar5, vq_Sharpness, ResetToDefault, True);
   InitTrackBar (TrackBar6, vq_Gamma, ResetToDefault, True);
   InitTrackBar (TrackBar7, vq_WhiteBalance, ResetToDefault, True);
   InitTrackBar (TrackBar8, vq_Gain, ResetToDefault, True);
end;
//---------------------------------------------------------------------------

procedure TForm_VideoQuality.FormShow(Sender: TObject);
begin
   CheckBox1.Checked := Form_MainDemo.VideoGrabber1.VideoQualityAuto;
   Form_VideoQuality.InitTrackBars (False);
end;
//---------------------------------------------------------------------------

procedure TForm_VideoQuality.OnTrackBarClick (Sender: TObject);
var
   Selector: integer;
   Reversed: Boolean;
begin
   if not CanUpdate then Exit;
   Selector := TTrackbar(Sender).Tag;
   if Selector < 0 then begin
      Selector := - Selector;
      Reversed := True;
   end
   else begin
      Reversed := False;
   end;
   Dec (Selector);
   if not Reversed then begin
      Form_MainDemo.VideoGrabber1.SetVideoQuality (TVideoQuality (Selector), TTrackbar (Sender).Position);
   end
   else begin
      Form_MainDemo.VideoGrabber1.SetVideoQuality (TVideoQuality (Selector), TTrackbar (Sender).Max - TTrackbar (Sender).Position + TTrackbar (Sender).Min);
   end;
end;
//---------------------------------------------------------------------------

procedure TForm_VideoQuality.CheckBox1Click(Sender: TObject);
begin
   Button1.Enabled := not CheckBox1.Checked;
   Form_MainDemo.VideoGrabber1.VideoQualityAuto := CheckBox1.Checked;
   InitTrackBars (False);
end;
//---------------------------------------------------------------------------

procedure TForm_VideoQuality.Button1Click(Sender: TObject);
begin
   InitTrackBars (True);
end;
//---------------------------------------------------------------------------

procedure TForm_VideoQuality.Button2Click(Sender: TObject);
begin
   Close;
end;
//---------------------------------------------------------------------------

end.
